<?php
// $Id: pnadmin.php,v 1.22 2003/05/15 15:55:29 garubi Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Stefano Garuti
// Purpose of file:  events administration display functions
// ----------------------------------------------------------------------

/**
 * The main administration function
 *
 * It shows the event administration menu and the event list with option to edit / delete / display
 */
function event_admin_main()
{   
	$output = new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'event::', '::', ACCESS_EDIT)) {
        $output->Text(_EVENTNOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(event_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);
	
	//*
	//Shows event table with edit/modify options
	//*
	$output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(event_admin_show());
    $output->SetInputMode(_PNH_PARSEINPUT);
		
	
		
    // Return output
    return $output->GetOutput();
}

/**
 * add new item
 */
function event_admin_new()
{
    // Create output object
    $output = new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'event::', '::', ACCESS_ADD)) {
        $output->Text(_EVENTNOAUTH);
        return $output->GetOutput();
    }

	// Setting up a scalar array, to avoid warnings in E_ALL state	
	// and to setup default values			
  pnModAPILoad('event', 'admin');
	$item = pnModAPIFunc('event','admin','defaults');			 
		
							 
    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(event_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_EVENTADD);

    // Start form
    $output->FormStart(pnModURL('event', 'admin', 'create'));
    $output->FormHidden('authid', pnSecGenAuthKey());
	
  	// Common part
    $output->SetInputMode(_PNH_VERBATIMINPUT);	
   	$output->Text(pnModFunc('event','admin','insertform',$item));
    $output->SetInputMode(_PNH_PARSEINPUT);
	    
    $output->FormSubmit(_EVENTADD);
    $output->FormEnd();

    // Return output
    return $output->GetOutput();
}


/**
 * shows item's data to correct wrong values
 */
function event_admin_correct()
{
	// get all event informations
	// we put all that stuffs in a function 'cause they are used either by 
	// event_admin_update and event_admin_create
	$item=pnModFunc('event','admin','getinfo');

    // Create output object
    $output = new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'event::', '::', ACCESS_EDIT)) {
        $output->Text(_EVENTNOAUTH);
        return $output->GetOutput();
    }
							 
    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(event_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_EVENTERROR);

    // Start form
    $output->FormStart(pnModURL('event', 'admin', 'create'));
    $output->FormHidden('authid', pnSecGenAuthKey());
	
	// Common part
    $output->SetInputMode(_PNH_VERBATIMINPUT);	
	$output->Text(pnModFunc('event','admin','insertform',$item));
    $output->SetInputMode(_PNH_PARSEINPUT);
	    
    $output->FormSubmit(_EVENTADD);
    $output->FormEnd();

    // Return output
    return $output->GetOutput();
}
/**
 * create item from event_admin_new() calling API function
 */
function event_admin_create()
{
	// get all event informations
	// we put all that stuffs in a function 'cause they are used either by 
	// event_admin_update and event_admin_create 
	$item=pnModFunc('event','admin','getinfo');

							 
	 // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('event', 'admin', 'view'));
				return true;
   }
	
    // Load API
    pnModAPILoad('event', 'admin');

	// Checks for a valid date and
	// compact day, year and month in a standard event format
	$dc_data = pnModAPIFunc('event','admin','impdate',
                        	array(	'dc_year'			 => $item['dc_year'],
																	'dc_month' 		 => $item['dc_month'], 
																	'dc_day' 			 => $item['dc_day']));
					
    if (!$dc_data) {
      	pnRedirect(pnModURL('event', 'admin', 'correct', $item));
				return true;
    }	
		$item['dc_data']=$dc_data;
		
		// checks for required fields
		// required year, month and day are already checked in previous
		// date check
		if (!pnModAPIFunc('event','admin','validate',$item)){
      	pnRedirect(pnModURL('event', 'admin', 'correct', $item));
				return true;		
		}

    // Pass to API to create a new item
    $dc_id = pnModAPIFunc('event','admin','create',$item);

    if ($dc_id != false) {
        // Success
        pnSessionSetVar('statusmsg', _EVENTCREATED);
    }
    pnRedirect(pnModURL('event', 'admin', 'view'));
    return true;
}

/**
 * udpate item from event_admin_modify calling API function
 */
function event_admin_update()
{
	// get all event informations
	// we put all that stuffs in a function 'cause they are used either by 
	// event_admin_update and event_admin_create
	$item=pnModFunc('event','admin','getinfo');

							 
	 // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('event', 'admin', 'view'));
        return true;
    }
	    
    // Load API
    pnModAPILoad('event', 'admin');

	// Check data by calling specific functions 
	
	// Checks for a valid date and
	// compact day, year and month in a standard event format
	$dc_data = pnModAPIFunc('event',
                        'admin',
                        'impdate',
                        array(	'dc_year' => $item['dc_year'],
																'dc_month' => $item['dc_month'], 
																'dc_day' => $item['dc_day']));
					
    if (!$dc_data) {
      	pnRedirect(pnModURL('event', 'admin', 'correct', $item));
		return true;
    }	
	$item['dc_data']=$dc_data;
	
	// aggiungi check per validit dati inseriti!!!
	
	
    // Pass to API
    if(pnModAPIFunc('event',
                    'admin',
                    'update',
                    $item)){ 
        // Success
        pnSessionSetVar('statusmsg', _EVENTUPDATED);
    }

    pnRedirect(pnModURL('event', 'admin', 'view'));

    return true;
}

/**
 * view items
 *
 * call show function to display summarized event infos: one event per row
 */
function event_admin_view()
{
    // Create output object
    $output = new pnHTML();

    if (!pnSecAuthAction(0, 'event::', '::', ACCESS_EDIT)) {
        $output->Text(_EVENTNOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(event_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

	// Show event table
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(event_admin_show());
    $output->SetInputMode(_PNH_PARSEINPUT);

    return $output->GetOutput();
}

/**
 * 
 */
function event_admin_modify()
{
    // Get parameters
    $dc_id = pnVarCleanFromInput('dc_id');

    // Create output object
    $output = new pnHTML();

    // Load user API to obtain item information function
    if (!pnModAPILoad('event', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // Get item information
    $item = pnModAPIFunc('event',
                         'user',
                         'get',
                         array('dc_id' => $dc_id));

    if ($item == false) {
        $output->Text(_EVENTNOSUCHITEM);
        return $output->GetOutput();
    }

    // Security check
    if (!pnSecAuthAction(0, 'event::', "::", ACCESS_EDIT)) {
        $output->Text(_EVENTNOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(event_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_EVENTEDIT);

    // Start form
    $output->FormStart(pnModURL('event', 'admin', 'update'));
    $output->FormHidden('authid', pnSecGenAuthKey());
    $output->FormHidden('dc_id', pnVarPrepForDisplay($dc_id));

	// Common part
    $output->SetInputMode(_PNH_VERBATIMINPUT);	
	$output->Text(pnModFunc('event','admin','insertform',$item));
    $output->SetInputMode(_PNH_PARSEINPUT);	

	
    $output->FormSubmit(_EVENTUPDATE);
    $output->FormEnd();
    
    return $output->GetOutput();
}


/**
 * delete item
 */
function event_admin_delete()
{
    // Get parameters
    $confirmation = pnVarCleanFromInput('confirmation');
		
	// get all event informations
	// we put all that stuffs in a function 'cause they are used either by 
	// event_admin_update and event_admin_create
	$item=pnModFunc('event','admin','getinfo');
	
        // Create output object
        $output = new pnHTML();
				
    // Security check
    if (!pnSecAuthAction(0, 'event::', "::$item[dc_id]", ACCESS_DELETE)) {
        $output->Text(_EVENTNOAUTH);
        return $output->GetOutput();
    }

    // Check for confirmation
    if (empty($confirmation)) {
        // No confirmation yet - get one
		
		// we want display all the event fields to ask for confirmation
		// so we can use userApi Display...
		// Load user API to obtain item information function
   		if (!pnModAPILoad('event', 'user')) {
        	$output->Text(_LOADFAILED);
        	return $output->GetOutput();
    	}

    	// Get item information
    	$item = pnModAPIFunc('event',
        	                 'user',
            	             'get',
                	         array('dc_id' => $item['dc_id']));

	    if ($item == false) {
    	    $output->Text(_EVENTNOSUCHITEM);
        	return $output->GetOutput();
	    }

        // Add menu to output
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(event_adminmenu());
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Add confirmation to output
        $output->Title(_EVENTDELETE);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
				pnModLoad('event','user');
				$output->Text(pnModFunc('event','user','showdetails',$item));
        $output->SetInputMode(_PNH_PARSEINPUT);
				
        $output->ConfirmAction(_EVENTCONFIRMDELETE,
                               pnModURL('event',
                                        'admin',
                                        'delete'),
                               _EVENTCANCELDELETE,
                               pnModURL('event',
                                        'admin',
                                        'view'),
                               array(	'dc_id' => $item['dc_id'],
							   			'da_data' => $item['dc_data']));

        // Return output
        return $output->GetOutput();
    }

    // Confirmation present
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('event', 'admin', 'view'));
        return true;
    }

    // Load API
    pnModAPILoad('event', 'admin');

    // Pass to API
    if (pnModAPIFunc('event',
                     'admin',
                     'delete',
                     array('dc_id' => $item['dc_id']))) {
        // Success
        pnSessionSetVar('statusmsg', _EVENTDELETED);
    }

    pnRedirect(pnModURL('event', 'admin', 'view'));
    
    return true;
}

/**
 * Modify configuration
 */
function event_admin_modifyconfig()
{
    // Create output object
    $output = new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'event::', '::', ACCESS_ADMIN)) {
        $output->Text(_EVENTNOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(event_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_EVENTEDITCONFIG);

    // Start form
    $output->FormStart(pnModURL('event', 'admin', 'updateconfig'));
    $output->FormHidden('authid', pnSecGenAuthKey());

    $output->TableStart();
	/**
	* bisogna settare:
	* num. concerti per pagina
	* 	per admin e per user
	* per quale colonna ordinare di default
	* e se ordinare ASC o DESC
	*	er admin e per user
	* ...
	* prossimi sviluppi:
	* inserire/modificare categorie dei concerti (per ora abbiamo pubblica e privata)
	*/
    // Items per page
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTPERPAGE));
    $row[] = $output->FormText('itemsperpage', pnVarPrepForDisplay(pnModGetVar('event', 'itemsperpage')), 3, 3);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Enable submission
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTENABLESUBMISSION));
		if (pnModGetVar('event', 'enable_submit')==1){
			 $checked=true;
		}
		else {
				 $checked=false;
		}
    $row[] = $output->FormCheckBox('enable_submit', $checked);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);		

   // Email setting
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTEMAILPENDING));
    $row[] = $output->FormText('email', pnModGetVar('event', 'email'), 40, 40);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->Linebreak(2);


    // End form
    $output->TableEnd();
    $output->Linebreak(2);
    $output->FormSubmit(_EVENTUPDATEMODIFY);
    $output->FormEnd();
    
		// Output some info on module:
		$infomod=pnModGetInfo(pnModGetIDFromName('event'));
		$output->LineBreak(2);
		$output->Text($infomod['displayname'].' - ver. '.$infomod['version'].' - (c) 2002-2003 by garubi - ');
        $output->URL('http://pnconcert.sourceforge.net', 'http://pnconcert.sourceforge.net');

    return $output->GetOutput();
}

/**
 * Update configuration
 *
 * if itemsperpage is not defined it become = 7
 */
function event_admin_updateconfig()
{
    // Get parameters
    $itemsperpage = pnVarCleanFromInput('itemsperpage');
    $enable_submit = pnVarCleanFromInput('enable_submit');
	$email = pnVarCleanFromInput('email');
 
    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('event', 'admin', 'view'));
        return true;
    }

    // Update module variables
    if (!isset($itemsperpage)) {
        $itemsperpage = 7;
    }
    pnModSetVar('event', 'itemsperpage', $itemsperpage);
    pnModSetVar('event', 'enable_submit', $enable_submit);
    pnModSetVar('event', 'email', $email);

    pnRedirect(pnModURL('event', 'admin', 'view'));

    return true;
}
/**
 * Main administration menu
 */
function event_adminmenu()
{
    // Create output object
    $output = new pnHTML();
		
		// Load API
	    pnModAPILoad('event', 'admin');

    // Start options menu
    $output->TableStart(_EVENT);
    $output->SetOutputModE(_PNH_RETURNOUTPUT);

    // Menu options
    $columns = array();
		if (pnSecAuthAction(0, 'event::', '::', ACCESS_OVERVIEW)) {
    	 $columns[] = $output->URL(pnModURL('event',
       						                                 'admin',
                  																 'new'),
                              										 _EVENTADD); 
		}
		if (pnSecAuthAction(0, 'event::', '::', ACCESS_ADD)) {
    	 $columns[] = $output->URL(pnModURL('event',
       						                                 'admin',
                  																 'viewpending'),
                              										 _EVENTSHOWPENDING.' ('.
																									 pnModAPIFunc('event',
   		                     'admin',
    	                    'countpending').')'); 
		}

		if (pnSecAuthAction(0, 'event::', '::', ACCESS_EDIT)) {
		    $columns[] = $output->URL(pnModURL('event',
    		                                    'admin',
        																		'view',
																						array('what' => 'nextconc')),
                              							_EVENTVIEWNEXT); 
    		$columns[] = $output->URL(pnModURL('event',
        	                                 'admin',
                                        'view',
																						array('what' => 'allconc')),
                              							_EVENTVIEWALL);
		}
		if (pnSecAuthAction(0, 'event::', '::', ACCESS_ADMIN)) {
		    $columns[] = $output->URL(pnModURL('event',
                                        'admin',
                                        'modifyconfig'),
     																		 _EVENTEDITCONFIG);
    }																				  
    $output->SetOutputMode(_PNH_KEEPOUTPUT);

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($columns);
    $output->SetInputMode(_PNH_PARSEINPUT);
		   
		$output->Linebreak(1);

    $output->TableEnd();
 
   // Display status message if any
    $output->BoldText(pnGetStatusMsg());
 		$output->Linebreak(1);
		
    // Return output
    return $output->GetOutput();
}


/**
* Shows the input/modify table.
* The starting and ending form part is left in the original functions 'cause
* is different for inserting and updating
* 
*	@see	concert_admin_new()
*	@see	concert_admin_modify()
*/

function event_admin_insertform ($item)
{
    // Create output object
    $output = new pnHTML();
   
    // Security check
    if (!pnSecAuthAction(0, 'event::', '::', ACCESS_MODERATE)) {
        $output->Text(_EVENTNOAUTH);
        return $output->GetOutput();
    }	

		// Start Table Editor and submitter info
    $output->TableStart('','',0);
		
		// Editor info
		if ($item['dc_user']){
			 $editor_info=pnUserGetVars($item['dc_user']);
			 $row = array();
    	 $output->SetOutputModE(_PNH_RETURNOUTPUT);
    	 $row[] = $output->Text(_LASTEDITOR.': '.$editor_info['uname'].' ('.$editor_info['name'].')');
    	 $output->SetInputMode(_PNH_VERBATIMINPUT);
			 $row[] = $output->Text('&nbsp;');
			 $output->SetOutputMode(_PNH_KEEPOUTPUT);
    	 $output->TableAddrow($row, 'left');
    	 $output->SetInputMode(_PNH_PARSEINPUT);
			 $row = array();
    	 $output->SetOutputModE(_PNH_RETURNOUTPUT);
    	 $row[] = $output->Text(_DATELASTEDIT.': '.$item['dc_data_modif']);							
    	 $output->SetInputMode(_PNH_VERBATIMINPUT);
			 $row[] = $output->Text('&nbsp;');
			 $output->SetOutputMode(_PNH_KEEPOUTPUT);
    	 $output->TableAddrow($row, 'left');
    	 $output->SetInputMode(_PNH_PARSEINPUT);
			 $row = array();
    	 $output->SetOutputModE(_PNH_RETURNOUTPUT);
    	 $output->SetInputMode(_PNH_VERBATIMINPUT);
			 $row[] = $output->Text('&nbsp;');
			 $row[] = $output->Text('&nbsp;');
			 $output->SetOutputMode(_PNH_KEEPOUTPUT);
    	 $output->TableAddrow($row, 'left');
    	 $output->SetInputMode(_PNH_PARSEINPUT);
		}
		
		// fields marked with '*' are required!
		$row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(_EVENTAREREQUIRED);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $row[] = $output->Text('&nbsp;');							
		$output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

		$output->TableEnd();

	// obtain the date informations	
	if ($item['dc_data']){	
		// Load API
    pnModAPILoad('event', 'admin');
    // Pass to API
    $date = pnModAPIFunc('event','admin','expdate',$item['dc_data']);
	}
	else {
		if ($item['dc_year']) {
			$date['year']= $item['dc_year'];
		}
		else {
			$date['year']= '';
		}
		if ($item['dc_month']) {
			$date['month']= $item['dc_month'];
		}
		else {
			$date['month']= '';
		}
		if ($item['dc_day']) {
			$date['day']= $item['dc_day'];
		}
		else {
			$date['day']= '';		
		}
	}

	// Create the day list
	$daylist = array();
	// a void entry: the first
	$daylist[]=array('id' => '', 'name' => '');
	for ($dayval=1; $dayval <=31; $dayval++)
	{
		$daylist[]=array('id' => "$dayval", 'name' => "$dayval");
	} 

	// Create the month list
	$monthlist = array();
	// a void entry: the first
	$monthlist[]=array('id' => '', 'name' => '');
	for ($monthval=1; $monthval <=12; $monthval++)
	{
		$monthlist[]=array('id' => "$monthval", 'name' => "$monthval");
	}

	//table 'input' start
	$output->tableStart('','',1);
	//row 'date' and 'where' start
	$output->TableRowStart();
	// col. 'date' start
	$output->TableColStart();
	// sub-table 'date start'
	$output->TAbleStart(_DATE,'',0);
  // Day dropdown
  $row = array();
	$output->SetOutputModE(_PNH_RETURNOUTPUT);
  $row[] = $output->Text(pnVarPrepForDisplay(_EVENTDAY).': * ');
  $row[] = $output->FormSelectMultiple('dc_day', $daylist, 0, 1, pnVarPrepForDisplay($date['day']));
  $output->SetOutputMode(_PNH_KEEPOUTPUT);
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->TableAddrow($row, 'left');
  $output->SetInputMode(_PNH_PARSEINPUT);

  // Month dropdown
  $row = array();
  $output->SetOutputModE(_PNH_RETURNOUTPUT);
  $row[] = $output->Text(pnVarPrepForDisplay(_EVENTMONTH).': * ');
	$row[] = $output->FormSelectMultiple('dc_month', $monthlist, 0, 1, pnVarPrepForDisplay($date['month']));
  $output->SetOutputMode(_PNH_KEEPOUTPUT);
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->TableAddrow($row, 'left');
  $output->SetInputMode(_PNH_PARSEINPUT);

  // Year 
  $row = array();
  $output->SetOutputModE(_PNH_RETURNOUTPUT);
  $row[] = $output->Text(pnVarPrepForDisplay(_EVENTYEAR).': * ');
	$row[] = $output->FormText('dc_year', pnVarPrepForDisplay($date['year']), 4, 4);
  $output->SetOutputMode(_PNH_KEEPOUTPUT);
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->TableAddrow($row, 'left');
  $output->SetInputMode(_PNH_PARSEINPUT);
	// sub-table 'date' end
	$output->TableEnd();
	// col. 'date' end
	$output->TableColEnd();
	
	// col. 'where' start
	$output->TableColStart();
	// table 'where' start
	$output->TableStart(_EVENTCITY,'',0);
	// City
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTCITY).': * ');
		$row[] = $output->FormText('dc_paese', pnVarPrepForDisplay($item['dc_paese']), 20, 50);
  $output->SetOutputMode(_PNH_KEEPOUTPUT);
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->TableAddrow($row, 'left');
  $output->SetInputMode(_PNH_PARSEINPUT);

	// Prov (state)
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTSTATE).': ');
		$row[] = $output->FormText('dc_prov', pnVarPrepForDisplay($item['dc_prov']), 2, 2);
  $output->SetOutputMode(_PNH_KEEPOUTPUT);
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->TableAddrow($row, 'left');
  $output->SetInputMode(_PNH_PARSEINPUT);

	// Country 
  $row = array();
  $output->SetOutputModE(_PNH_RETURNOUTPUT);
  $row[] = $output->Text(pnVarPrepForDisplay(_EVENTCOUNTRY).': ');
	$row[] = $output->FormText('dc_stato', pnVarPrepForDisplay($item['dc_stato']), 10, 10);
  $output->SetOutputMode(_PNH_KEEPOUTPUT);
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->TableAddrow($row, 'left');
  $output->SetInputMode(_PNH_PARSEINPUT);
	// table 'where' end	
	$output->TableEnd();
	// col. 'where' end
	$output->TableColEnd();
	// row 'date and 'where' end
	$output->TableRowEnd();
	
	// row 'pub' and 'contact' start
	$output->TableRowStart();
	// col. 'pub' start
	$output->TableColStart();
	//table 'concert hall' ;-)
	$output->TableStart(_EVENTVENUE);
	// Locale 
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTVENUE));
    $row[] = $output->FormText('dc_locale', pnVarPrepForDisplay($item['dc_locale']), 20, 50);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

	// URL Locale 
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTURL));
    $row[] = $output->FormText('dc_url_locale', pnVarPrepForDisplay($item['dc_url_locale']), 20, 125);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

	// Address
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTADDRESS));
    $row[] = $output->FormText('dc_indirizzo_locale', pnVarPrepForDisplay($item['dc_indirizzo_locale']), 20, 125);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
		// table 'pub' end
		$output->TableEnd();
		// col. 'pub' end
		$output->TableColEnd();
		
		// col. 'contact' start
		$output->TableColStart();
		$output->TableStart(_EVENTCONTACT);
	// Info Email Name
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTMAILNOME));
    $row[] = $output->FormText('dc_infomailnome1', pnVarPrepForDisplay($item['dc_infomailnome1']), 20, 100);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

	// Info Email Address
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
		$row[] = $output->Text(pnVarPrepForDisplay(_EVENTMAILADDRESS));
    $output->SetInputMode(_PNH_VERBATIMINPUT);
		$row[] = $output->FormText('dc_infomailaddr1', $item['dc_infomailaddr1'], 20, 100);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

	// Info Tel 1 Name
   // $row = array();
  //  $output->SetOutputModE(_PNH_RETURNOUTPUT);
  //  $row[] = $output->Text(pnVarPrepForDisplay(_EVENTTEL1NAME));
  //  $row[] = $output->FormText('dc_infotelnome1', pnVarPrepForDisplay($item['dc_infotelnome1']), 20, 80);
   // $output->SetOutputMode(_PNH_KEEPOUTPUT);
   // $output->SetInputMode(_PNH_VERBATIMINPUT);
   // $output->TableAddrow($row, 'left');
   // $output->SetInputMode(_PNH_PARSEINPUT);

	// Info Tel 1 Number
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTTEL1NUMBER));
    $row[] = $output->FormText('dc_infotel1', pnVarPrepForDisplay($item['dc_infotel1']), 20, 15);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

	// Info Tel 2 Name
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTTEL2NAME));
    $row[] = $output->FormText('dc_infotelnome2', pnVarPrepForDisplay($item['dc_infotelnome2']), 20, 80);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

	// Info Tel 2 Number
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTTEL2NUMBER));
    $row[] = $output->FormText('dc_infotel2', pnVarPrepForDisplay($item['dc_infotel2']), 20, 15);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
		$output->TAbleENd();
		
		// col. 'contact' end
		$output->TableColEnd();
		// row 'pub' and 'contact' end
		$output->TableRowEnd();
		
$output->TableRowStart();
$output->TableColStart();
$output->TAbleStart(_EVENTSTATUSANDCAT);
	// concert status
	$concstati = array();
	$concstati[] = array('id' => '0', 'name' => _EVENTCONF);
	$concstati[] = array('id' => '1', 'name' => _EVENTNOTCONF);
	$concstati[] = array('id' => '2', 'name' => _EVENTCANCELED);
	$concstati[] = array('id' => '3', 'name' => _EVENTSOLDOUT);
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTSTATUS));
    $row[] = $output->FormSelectMultiple('dc_conf', $concstati, 0, 1, $item['dc_conf']);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

	// concert category
	$conccat = array();
	$conccat[] = array('id' => '0', 'name' => _CONCCATPUBB);
	$conccat[] = array('id' => '1', 'name' => _CONCCATRESERVED);
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTCATEGORY));
    $row[] = $output->FormSelectMultiple('dc_category', $conccat, 0, 1, $item['dc_category']);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
$output->TableEnd();
$output->TableColEnd();

		$output->TAbleColStart();
		$output->TableStart(_EVENTNOTES);
		
	// Annotations
    $row = array();
    $output->SetOutputModE(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_EVENTANNOTATIONS));
    $row[] = $output->FormTextArea('dc_note', pnVarPrepHTMLDisplay($item['dc_note']), 6, 20);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
$output->TableEnd();
$output->TableColEnd();
$output->TAbleRowEnd();

	// concert language (only to filter on display)
	
    // End table
    $output->TableEnd();

	// User id, to keep tracks of modifications
	$output->FormHidden('dc_user', $item['dc_user']);
	$output->FormHidden('dc_id', $item['dc_id']);
	
	

	return $output->GetOutput();
}
/**
* Shows concerts admin table with edit/delete links
* internal function: it's called from every other function needs to show the admin concert table
*/
function event_admin_show() 
{
    // Get parameters from whatever input we need.  All arguments to this
    // function should be obtained from pnVarCleanFromInput(), getting them
    // from other places such as the environment is not allowed, as that makes
    // assumptions that will not hold in future versions of PostNuke
    list($startnum,$what) = pnVarCleanFromInput('startnum','what');
	
    // Create output object
    $output = new pnHTML();
	
	// Load user API to obtain item information function
    if (!pnModAPILoad('event', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

	// Get number of items (show it after action title and use it for the Pager function
	$numitems = pnModAPIFunc('event', 'user', 'countitems',$what);
    // Title
	if ($what=='allconc'){
	    $output->Title(_EVENTVIEWALL);
	}
	else{
	    $output->Title(_EVENTVIEWNEXT);
	}

    $output->Linebreak(1);
		
	$output->Text(_THEREARE.' '.$numitems.' '._EVENTS);
    $output->Linebreak(2);

    // Get item information
    $items = pnModAPIFunc('event', 'user', 'getall',
							array(	'startnum' => $startnum,
                                	'numitems' => pnModGetVar('event',
                                                          'itemsperpage'),
									'what'=> $what));
							
    // Start output table
    $output->TableStart('','',1);

    foreach ($items as $item) {

		// split date calling proper internal (module) function
	    if (!pnModAPILoad('event', 'admin')) {
	        $output->Text(_LOADFAILED);
	        return $output->GetOutput();
	    }	
		
		$date=pnModAPIFunc('event','admin','expdate',$item['dc_data']);
		if (!$date){
	        $output->Text(_DATE_ERROR);
	        return $output->GetOutput();
		}

        if (pnSecAuthAction(0, 'event::', ":$item[dc_category]:$item[dc_id]", ACCESS_OVERVIEW)) {

            $output->SetOutputMode(_PNH_KEEPOUTPUT);
			
			$output->TableRowStart();
				$output->TableColStart();
					$output->Text($date['dateshort']);
					if ($item['dc_category']==1){
						 $output->LineBreak();
						 $output->BoldText(_CONCCATRESERVED);
					}
				$output->TableColEnd();
				
				$output->TableColStart();
					$output->BoldText($item['dc_paese']);
					if ($item['dc_prov']) {
						 $output->Text(' ('.$item['dc_prov'].') '.$item['dc_stato']);
				  }
				$output->TableColEnd();
				
				$output->TableColStart();
					if ($item['dc_url_locale']){
						if ($item['dc_locale']){					
							$output->URL($item['dc_url_locale'],$item['dc_locale']);
						}
						else {
							$output->URL($item['dc_url_locale'],$item['dc_url_locale']);						
						}
					}
					else {
						if ($item['dc_locale']){
							$output->BoldText($item['dc_locale']);
						}
						else {
						$output->SetInputMode(_PNH_VERBATIMINPUT);
							$output->Text('&nbsp;');
						$output->SetInputMode(_PNH_PARSEINPUT);
						}
					}
				$output->TableColEnd();
				
				$output->TableColStart();
					switch ($item['dc_conf']){
						case 1:
							$output->BoldText(_EVENTNOTCONF);						
						break;
				
						case 2:
							$output->BoldText(_EVENTCANCELED);						
						break;
						
						case 3:
							$output->BoldText(_EVENTSOLDOUT);	
						break;

						default:
							$output->BoldText(_EVENTCONF);
						break;	
					}
					$editor_info=pnUserGetVars($item['dc_user']);
					$output->LineBreak();
					$output->Text(_LASTEDITOR.': '.$editor_info['uname'].' ('.$editor_info['name'].')');
					$output->LineBreak();
					$output->Text(_DATELASTEDIT.': '.$item['dc_data_modif']);							
				$output->TableColEnd();
				$dc_category=$item[dc_category];
				$dc_id=$item[dc_id];
				if (pnSecAuthAction(0, 'event::', ":$dc_category:$dc_id", ACCESS_EDIT)) {
					$output->TableColStart();
                		$output->URL(pnModURL('event',
                                              'admin',
                                              'modify',
                                              array(	'dc_id' => $item['dc_id'])),
                        	                  _EDIT);
                	if (pnSecAuthAction(0, 'event::', ":$dc_category:$dc_id", ACCESS_DELETE)) {
						$output->LineBreak();
                    	$output->URL(pnModURL('event',
                                              'admin',
                                              'delete',
                                              array('dc_id' => $item['dc_id'])),
                                              _DELETE);
					}							  
					$output->TableColEnd();
				}

				
			$output->TableRowEnd();	
					
            $output->SetInputMode(_PNH_PARSEINPUT);
			
        }
    }
    $output->TableEnd();
	
	if (!pnModGetVar('event', 'itemsperpage')){
		die ('Could not get itemsperpage var');
	}	

    // Call the pnHTML helper function to produce a pager in case of there
    // being many items to display.
    //
    // Note that this function includes another user API function.  The
    // function returns a simple count of the total number of items in the item
    // table so that the pager function can do its job properly
    $output->Pager($startnum, $numitems, pnModURL('event', 'admin', 'view', array('startnum' => '%%','what'=>$what)), pnModGetVar('event', 'itemsperpage'));

    // Return the output that has been generated by this function
	return $output->GetOutput(); 

}
/**
* Obtains concert informations from input, check it and return the whole associative array
* 
* @see 	concert_admin_create()
*	@see	concert_admin_update()
* @private
*/
function event_admin_getinfo() {
    // Get parameters
    list (	$dc_id,
			$dc_paese,
			$dc_prov,
			$dc_stato,
			$dc_locale,
			$dc_note,
			$dc_infomailnome1,
			$dc_infomailaddr1,
			$dc_infotel1,
			$dc_infotel2,
			$dc_url_locale,
			$dc_indirizzo_locale,
			$dc_day,
			$dc_month,
			$dc_year,
			$dc_conf,
			$dc_category,
			$dc_lang,
			$dc_infotelnome1,
			$dc_infotelnome2,
			$dc_approved,
			$dc_submitter,
			$action
		) = pnVarCleanFromInput(		'dc_id',
										'dc_paese',
							 			'dc_prov',
							 			'dc_stato',
										'dc_locale',
							 			'dc_note',
										'dc_infomailnome1',
							 			'dc_infomailaddr1',
							 			'dc_infotel1',
							 			'dc_infotel2',
							 			'dc_url_locale',
							 			'dc_indirizzo_locale',
							 			'dc_day',
										'dc_month',
										'dc_year',
							 			'dc_conf',
							 			'dc_category',
							 			'dc_lang',
							 			'dc_infotelnome1',
							 			'dc_infotelnome2',
										'dc_approved',
										'dc_submitter',
										'action');
	
	$item=array ('dc_id'=>$dc_id,
	'dc_paese'=> $dc_paese,
'dc_prov'=> $dc_prov,
'dc_stato'=> $dc_stato,
'dc_locale'=> $dc_locale,
'dc_note'=>$dc_note,
'dc_infomailnome1'=> $dc_infomailnome1,
'dc_infomailaddr1'=>$dc_infomailaddr1,
'dc_infotel1'=>$dc_infotel1,
'dc_infotel2'=> $dc_infotel2,
'dc_url_locale'=>$dc_url_locale,
'dc_indirizzo_locale'=>$dc_indirizzo_locale,
'dc_day'=> $dc_day,
'dc_month'=>$dc_month,
'dc_year'=>$dc_year,
'dc_conf'=>$dc_conf,
'dc_category'=>$dc_category,
'dc_lang'=> $dc_lang,
'dc_infotelnome1'=>$dc_infotelnome1,
'dc_infotelnome2'=>$dc_infotelnome2,
'dc_approved'=>$dc_approved,
'dc_submitter'=>$dc_submitter,
'action'=>$action);

	return $item;
}

function event_admin_viewpending ()
{
    // Create output object
    $output = new pnHTML();

    if (!pnSecAuthAction(0, 'event::', '::', ACCESS_ADD)) {
        $output->Text(_EVENTNOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(event_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

	// Show concert table
    $output->SetInputMode(_PNH_VERBATIMINPUT);

        // Get parameters from whatever input we need.  All arguments to this
    // function should be obtained from pnVarCleanFromInput(), getting them
    // from other places such as the environment is not allowed, as that makes
    // assumptions that will not hold in future versions of PostNuke
    $startnum = pnVarCleanFromInput('startnum');
	
	// Load admin API to obtain item information function
    if (!pnModAPILoad('event', 'admin')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // Title

	    $output->Title(_EVENTSVIEWPENDING);


    $output->Linebreak(1);

    // Get item information
    $items = pnModAPIFunc('event', 'admin', 'getpending',
							array(	'startnum' => $startnum,
                                	'numitems' => pnModGetVar('event',
                                                          'itemsperpage')));
		
	
	// Get number of items (show it after action title and use it for the Pager function
	//$numitems = count($items);	
	$numitems=pnModAPIFunc('event',
   		                     'admin',
    	                    'countpending');
	$output->Text(_THEREARE.' '.$numitems.' '._EVENTSPENDING);
    $output->Linebreak(2);

							
    // Start output table
    $output->TableStart('','',1);

    foreach ($items as $item) {

		// split date calling proper internal (module) function
		
		$date=pnModAPIFunc('event','admin','expdate',$item['dc_data']);
		if (!$date){
	        $output->Text(_DATE_ERROR);
	        return $output->GetOutput();
		}

        if (pnSecAuthAction(0, 'event::', ":$item[dc_category]:$item[dc_id]", ACCESS_ADD)) {

            $output->SetOutputMode(_PNH_KEEPOUTPUT);
			
			$output->TableRowStart();
				$output->TableColStart();
					$output->Text($date['dateshort']);
					if ($item['dc_category']==1){
						 $output->LineBreak();
						 $output->BoldText(_CONCCATRESERVED);
					}
				$output->TableColEnd();
				
				$output->TableColStart();
					$output->BoldText($item['dc_paese']);
					if ($item['dc_prov']) {
						 $output->Text(' ('.$item['dc_prov'].') '.$item['dc_stato']);
				  }
				$output->TableColEnd();
				
				$output->TableColStart();
					if ($item['dc_url_locale']){
						if ($item['dc_locale']){					
							$output->URL($item['dc_url_locale'],$item['dc_locale']);
						}
						else {
							$output->URL($item['dc_url_locale'],$item['dc_url_locale']);						
						}
					}
					else {
						if ($item['dc_locale']){
							$output->BoldText($item['dc_locale']);
						}
						else {
						$output->SetInputMode(_PNH_VERBATIMINPUT);
							$output->Text('&nbsp;');
						$output->SetInputMode(_PNH_PARSEINPUT);
						}
					}
				$output->TableColEnd();
				
				$output->TableColStart();
					switch ($item['dc_conf']){
						case 1:
							$output->BoldText(_EVENTNOTCONF);						
						break;
				
						case 2:
							$output->BoldText(_EVENTCANCELED);						
						break;
						
						case 3:
							$output->BoldText(_EVENTSOLDOUT);	
						break;

						default:
							$output->BoldText(_EVENTCONF);
						break;	
					}
					$editor_info=pnUserGetVars($item['dc_submitter']);
					$output->LineBreak();
					$output->Text(_EVENTSUBMITTEDBY.': '.$editor_info['uname'].' ('.$editor_info['name'].')');
					$output->LineBreak();
					$output->Text(_EVENTSUBMITTEDWHEN.': '.$item['dc_data_modif']);							
				$output->TableColEnd();
				$dc_category=$item[dc_category];
				$dc_id=$item[dc_id];
					$output->TableColStart();
            $output->URL(pnModURL('event',
                                              'admin',
                                              'displaypending',
                                              array('dc_id' => $item['dc_id'])),
                                              _EVENTPREVIEW);
							  
					$output->TableColEnd();
		
					$output->TableRowEnd();	
					
      		$output->SetInputMode(_PNH_PARSEINPUT);
        }
    }
    $output->TableEnd();
	
	if (!pnModGetVar('event', 'itemsperpage')){
		die ('Could not get itemsperpage var');
	}	

    // Call the pnHTML helper function to produce a pager in case of there
    // being many items to display.
    //
    // Note that this function includes another user API function.  The
    // function returns a simple count of the total number of items in the item
    // table so that the pager function can do its job properly
    $output->Pager($startnum, $numitems, pnModURL('event', 'admin', 'viewpending', array('startnum' => '%%')), pnModGetVar('event', 'itemsperpage'));

    // Return the output that has been generated by this function
	return $output->GetOutput(); 
}

/*
* Show detailed information on a single pending event
* and let admin (ADD) to change any of it.
* Show the commands for approve, delete, suspend and preview the pending concert
*/
function event_admin_displaypending($args){
    // Get parameters
    $dc_id = pnVarCleanFromInput('dc_id');

    // Override if needed from argument array
    extract($args);
		
    // Create output object
    $output = new pnHTML();
		
	if ((!isset($dc_id))) {
        $output->Text(_CONCARGSERROR.' display pending');
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(event_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Load API
    if (!pnModAPILoad('event', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // Get item
    $item = pnModAPIFunc('event',
                          'user',
                          'get',
                          array('dc_id' => $dc_id));

		// Display title
    $output->Linebreak(2);		
	  $output->Title(_EVENTAPPROVE);
		
		if ($item == false) {
        $output->Text(_EVENTITEMFAILED);
   			$output->Linebreak(2);
			 return $output->GetOutput();
	  }
		
    // Load Func
    if (!pnModLoad('event', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
		
		// Dispaly concert preview 
		$output->TableStart(_EVENTPREVIEW,'',1);
		$output->TAbleRowStart();
		$output->TableColStart();
    $output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->Text(pnModFunc('event','user','showdetails',$item));
    $output->SetInputMode(_PNH_PARSEINPUT);
		$output->TableColEnd();
		$output->TableRowEnd();
		$output->TableEnd();
	
  	$output->Linebreak(2);
		
				
		// Display concert edit form		
		$output->TableStart(_EVENTEDIT,'',0);

		// Display submitter info and email/messages links
		$output->TableRowStart();
		$output->TableColStart('','left');		
		$editor_info=pnUserGetVars($item['dc_submitter']);
		$output->Text(_EVENTSUBMITTEDBY.': '.$editor_info['uname'].' ('.$editor_info['name'].') - ');
		$output->TableColEnd();
		$output->TableRowEnd();
		$output->TableRowStart();
		$output->TableColStart('','left');		
		$output->Text(_EVENTSUBMITTEDWHEN.': '.$item['dc_data_modif']);
		$output->TableColEnd();
		$output->TableRowEnd();
		$output->TableEnd();
		
		// Start form
		$output->TAbleStart();
		$output->TableRowStart();
		$output->TableColStart('','left');		
    $output->FormStart(pnModURL('event', 'admin', 'approve'));
    $output->FormHidden('authid', pnSecGenAuthKey());
    $output->FormHidden('dc_id', pnVarPrepForDisplay($item['dc_id']));

    $output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->Text(pnModFunc('event','admin','insertform',$item));
    $output->SetInputMode(_PNH_PARSEINPUT);
		
		$actionlist = array();
		
	  $actionlist[] = array('id' => 'actsave', 'name' => _EVENTSAVE);
	  $actionlist[] = array('id' => 'actapprove', 'name' => _EVENTAPPROVE);
	  $actionlist[] = array('id' => 'actdelete', 'name' => _EVENTDELETE);

		$output->FormSelectMultiple('action', $actionlist, 0, 1, 'actapprove');
		
		$output->FormSubmit(_EVENTSUBMIT);
    $output->FormEnd();
		$output->TableColEnd();	
		$output->TableRowEnd();
		$output->TableEnd();
	
		//		Salva le modifiche
		//		Cancella
    return $output->GetOutput();
}
/**
 * approve, save or delete concert calling API function
 */
function event_admin_approve()
{
	// get all concert informations
	// we put all that stuffs in a function 'cause they are used either by 
	// concert_admin_update and concert_admin_create
	$item=pnModFunc('event','admin','getinfo');

	// if admin has set DELETE, then pass the whole control to the delete function
	if($item['action']=="actdelete"){
        pnRedirect(pnModURL('event', 'admin', 'delete', array('dc_id'=>$item['dc_id'])));
        return true;
	}
							 
	 // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY.' func approve');
        pnRedirect(pnModURL('event', 'admin', 'viewpending'));
        return true;
    }
	    
    // Load API
    pnModAPILoad('event', 'admin');

	// Check data by calling specific functions 
	
	// Checks for a valid date and
	// compact day, year and month in a standard concert format
	$dc_data = pnModAPIFunc('event',
                        'admin',
                        'impdate',
                        array(	'dc_year' => $item['dc_year'],
																'dc_month' => $item['dc_month'], 
																'dc_day' => $item['dc_day']));
					
    if (!$dc_data) {
      	pnRedirect(pnModURL('event', 'admin', 'displaypending', $item));
		return true;
    }	
	$item['dc_data']=$dc_data;
	
		// checks for required fields
		// required year, month and day are already checked in previous
		// date check
		if (!pnModAPIFunc('event','admin','validate',$item)){
      	pnRedirect(pnModURL('event', 'admin', 'correct', $item));
				return true;		
		}
	
	if($item['action']=="actapprove"){
		$item['dc_approved']=1;
		$successmsg=_EVENTAPPROVED;
	}
	else {
		$item['dc_approved']=0;
		$successmsg=_EVENTUPDATED;
	}
	
    // Pass to API
    if(pnModAPIFunc('event',
                    'admin',
                    'update',
                    $item)){ 
        // Success
        pnSessionSetVar('statusmsg', $successmsg);
    }

    pnRedirect(pnModURL('event', 'admin', 'viewpending'));

    return true;
}
?>
