<?php
// $Id: next.php,v 1.13 2003/06/03 12:37:16 garubi Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Stefano Garuti
// Purpose of file: Show next X event scheduled in a sideblock
// ----------------------------------------------------------------------

/**
 * initialise block
 */
function event_nextblock_init()
{
    // Security
    pnSecAddSchema('event:nextblock:', 'Block title::');
}

/**
 * get information on block
 */
function event_nextblock_info()
{
    // Values
    return array('text_type' => 'Next',
                 'module' => 'event',
                 'text_type_long' => 'Show next X events scheduled',
                 'allow_multiple' => true,
                 'form_content' => false,
                 'form_refresh' => false,
                 'show_preview' => true);
}

/**
 * display block
 */
function event_nextblock_display($blockinfo)
{
    // Security check
    if (!pnSecAuthAction(0,
                         'event:nextblock:',
                         "$blockinfo[title]::",
                         ACCESS_OVERVIEW)) {
        return;
    }
	
    // Create output object
    $output = new pnHTML();

    // Get variables from content block
    $vars = pnBlockVarsFromContent($blockinfo['content']);

    // Defaults
  if (empty($vars['numitems'])) {
        $vars['numitems'] = 5;
    }

	// Load user API to obtain item information function
    if (!pnModAPILoad('event', 'user')) {
        return false;
    }
	// Load user API to obtain item information function
    if (!pnModAPILoad('event', 'admin')) {
        return false;
    }

    // Get item information
    if (!($items = pnModAPIFunc('event', 'user', 'getall',array(	'numitems' => $vars['numitems'])))){
        return false;

		}
		
		if (pnSecAuthAction(0,'event::',":::",ACCESS_EDIT)) {
	    //$output->Linebreak();
			$output->Text('[');

			$output->URL(pnModURL('event',
                                       'admin',
                                       'view'),
				       _EVENTEDIT);
			$output->Text(']');
	}
		// if the user can submit events and the event submission is enabled
		// we show the link to submit it
		//if (pnSecAuthAction(0,'event::',"::",ACCESS_MODERATE)&& $vars['event_submit'] && pnModGetVar('event','enable_submit')) {
		//	$output->Text(' [');
		//	 $output->URL(pnModURL('event','user','submit'),_EVENTSUBMIT);
		//	$output->Text(']');
		//}
		// if the user can approve events, here we display an advice
		// to tell him how many events are pending approvation...
		// but we display it only if there are some..
		if (pnSecAuthAction(0,'event::',"::",ACCESS_ADD) && ($num_pending=pnModAPIFunc('event','admin','countpending'))&& $vars['show_numpending']) {
			$output->Text(' [');
			 $output->URL(pnModURL('event','admin','viewpending'),_EVENTPENDING.': '.$num_pending);
			$output->Text(']');
		}

// then we display the events info...
   $output->TableStart();
   
    foreach ($items as $item) {
        if (pnSecAuthAction(0,'event::',":$item[dc_category]:$item[dc_id]",ACCESS_OVERVIEW)) {
            $output->TableRowStart();
			// split date calling proper internal (module) function
	   		if (!pnModAPILoad('event', 'admin')) {
	        	return false;
	    	}		
			$date=pnModAPIFunc('event','admin','expdate',$item['dc_data']);
			if (!$date){
	        	return false;
			}
            $output->TableColStart();
			switch($item['dc_conf']){
				case 0:
					$output->SetInputMode(_PNH_VERBATIMINPUT);
					$output->Text(_EVENTDOTICO);
					$output->SetInputMode(_PNH_PARSEINPUT);	
                    $status='';
					break;			
				case 1:
                    // event status is 'not confirmed'
					$output->SetInputMode(_PNH_VERBATIMINPUT);
					$output->Text(_EVENTNOTCONFICO);
					$output->SetInputMode(_PNH_PARSEINPUT);
                    $status=' - '._EVENTNOTCONF;
					break;
				case 2:
         			// event status is 'canceled'
					$output->SetInputMode(_PNH_VERBATIMINPUT);
					$output->Text(_EVENTCANCELEDICO);
					$output->SetInputMode(_PNH_PARSEINPUT);
                    $status=' - '._EVENTCANCELED;
					break;
                case 3:
                     // event status is ''sold out'
					$output->SetInputMode(_PNH_VERBATIMINPUT);
					$output->Text(_EVENTSOLDOUTICO);
					$output->SetInputMode(_PNH_PARSEINPUT);
                    $status=' - '._EVENTSOLDOUT;
                break;
			}
   $output->TableColEnd();
            $output->TableColStart(1,'left');

			if ($item['dc_category']==1){
						 $output->Text('(');
			}
            if ($item['dc_conf']==2){
					$output->SetInputMode(_PNH_VERBATIMINPUT);
                    $output->text('<s>');
					$output->SetInputMode(_PNH_PARSEINPUT);
            }
			// write down date, city and (if present) state.		
			$output->Text($date['datecompact']);
   $output->TableColEnd();
            $output->TableColStart(1,'left');
            if ($item['dc_conf']==2){
					$output->SetInputMode(_PNH_VERBATIMINPUT);
                    $output->text('<s>');
					$output->SetInputMode(_PNH_PARSEINPUT);
            }

           	$output->URL(pnModURL('event','user','display', array('dc_id'=>$item['dc_id'])),
                             $item['dc_locale']);
			if ($item['dc_paese']){
				$output->Text(' ('.$item['dc_paese'].')');
			}
			if ($item['dc_category']==1){
						 $output->Text(')');
			}
               if ($item['dc_conf']==2){
					$output->SetInputMode(_PNH_VERBATIMINPUT);
                    $output->text('</s>');
					$output->SetInputMode(_PNH_PARSEINPUT);
            }

   $output->TableColEnd();
   $output->TableColStart();
$output->SetInputMode(_PNH_VERBATIMINPUT);
                	$output->URL(pnModURL('event','user','display', array('dc_id'=>$item['dc_id'])));
					$output->SetInputMode(_PNH_PARSEINPUT);

   $output->TableColEnd();
     $output->TableRowEnd();
        }
    } // end while
    $output->TableEnd();
    // if the user can submit events and the event submission is enabled
		// we show the link to submit it
		if (pnSecAuthAction(0,'event::',"::",ACCESS_MODERATE)&& $vars['show_submit'] && pnModGetVar('event','enable_submit')) {
			$output->Text(' [');
			 $output->URL(pnModURL('event','user','submit'),_EVENTSUBMIT);
			$output->Text(']');
		}
    /*
	$output->SetInputMode(_PNH_VERBATIMINPUT);
	$output->Text('<hr width="80%" align="center">');
	$output->SetInputMode(_PNH_PARSEINPUT);					
	$output->BoldText('?');
	$output->Text(' - '._EVENTNOTCONF);
    $output->Linebreak();
	$output->BoldText('!');
	$output->Text(' - '._EVENTCANCELED);
    */

    // Populate block info and pass to theme
    $blockinfo['content'] = $output->GetOutput();
    return themesideblock($blockinfo);
}


/**
 * modify block settings
 */
function event_nextblock_modify($blockinfo)
{
    // Create output object
    $output = new pnHTML();

    // Get current content
    $vars = pnBlockVarsFromContent($blockinfo['content']);

    // Defaults
    if (empty($vars['numitems'])) {
        $vars['numitems'] = 5;
    }
   if (empty($vars['show_submit'])) {
        $vars['show_submit'] = 0;
    }
   if (empty($vars['show_numpending'])) {
        $vars['show_numpending'] = 0;
    }
		

    // Create row
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(_NUMITEMS);
    $row[] = $output->FormText('numitems',
                               pnVarPrepForDisplay($vars['numitems']),
                               5,
                               5);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    // Add row
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

	  // Create row
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(_EVENTSHOWSUBMIT);
		if ($vars['show_submit']==1){
			 $checked=true;
		}
		else {
				 $checked=false;
		}
    $row[] = $output->FormCheckBox('show_submit', 
                               $checked);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
		// Add row
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

			  // Create row
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(_EVENTSHOWNUMPENDING);
		if ($vars['show_numpending']==1){
			 $checked=true;
		}
		else {
				 $checked=false;
		}
    $row[] = $output->FormCheckBox('show_numpending', 
                               $checked);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    // Add row
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Return output
    return $output->GetOutput();
}

/**
 * update block settings
 */
function event_nextblock_update($blockinfo)
{
    $vars['numitems'] = pnVarCleanFromInput('numitems');
		$vars['show_submit'] = pnVarCleanFromInput('show_submit');
    $vars['show_numpending'] = pnVarCleanFromInput('show_numpending');

    $blockinfo['content'] = pnBlockVarsToContent($vars);

    return $blockinfo;
}

?>
