<?php
// $Id: pnuser.php,v 1.24 2003/05/12 12:25:11 garubi Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Stefano Garuti
// Purpose of file:  concert user display functions
// ----------------------------------------------------------------------

/**
 * the main user function
 */
function concert_user_main()
{
    // Create output object
    $output = new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'concert::', '::', ACCESS_OVERVIEW)) {
        $output->Text(_CONCERTNOAUTH);
        return $output->GetOutput();
    }
		
		// Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(concert_usermenu());
    $output->SetInputMode(_PNH_PARSEINPUT);



    // Return output
    return $output->GetOutput();
}

/**
 * view items
 */
function concert_user_view()
{
    // Create output object
    $output = new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'concert::', '::', ACCESS_OVERVIEW)) {
        $output->Text(_CONCERTNOAUTH);
        return $output->GetOutput();
    }
		
    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(concert_usermenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

	//*
	//Shows the concert table
	//*
	$output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnModFunc('concert','user','show'));
    $output->SetInputMode(_PNH_PARSEINPUT);

	return $output->GetOutput();
}

/**
 * display detailed concert information
 *
 * @param array $args
 */
 
 function concert_user_display($args)
{
    // Get parameters from user
    $dc_id = pnVarCleanFromInput('dc_id');

    // Override if needed from argument array
    extract($args);
    // Create output object
    $output = new pnHTML();
		
	if ((!isset($dc_id))) {
        $output->Text(_CONCARGSERROR.' display conc');
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(concert_usermenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Load API
    if (!pnModAPILoad('concert', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // Get item
    $item = pnModAPIFunc('concert',
                          'user',
                          'get',
                          array('dc_id' => $dc_id));

		// Display title
    $output->Linebreak(2);		
	  $output->Title(_CONCERTVIEWDETAILS);
		
		if ($item == false) {
        $output->Text(_CONCERTITEMFAILED);
   			$output->Linebreak(2);
			 return $output->GetOutput();
	  }
		
		// Security check
		// we don't need any security check here 'cause it's already done in userapi - get
		 
    $output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->Text(pnModFunc('concert','user','showdetails',$item));
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Add hooks
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnModCallHooks('item',
                                 'display',
                                 $dc_id,
                                 pnModURL('concert',
                                          'user',
                                          'display',
                                          array('dc_id' => $item['dc_id']))));
    $output->SetInputMode(_PNH_PARSEINPUT);

    return $output->GetOutput();
		
}


/**
 * generate menu fragment
 */
function concert_usermenu()
{
    // Create output object
    $output = new pnHTML();

    // Menu table
    $output->TableStart(_CONCERT);
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $columns = array();
    $columns[] = $output->URL(pnModURL('concert',
                                       'user',
                                       'view',
									   array('what' => 'nextconc')),
				       _CONCERTVIEWNEXT);
    $columns[] = $output->URL(pnModURL('concert',
                                       'user',
                                       'view',
                                       array('what' => 'allconc')),
				       _CONCERTVIEWALL);
	if (pnSecAuthAction(0, 'concert::', "::", ACCESS_EDIT)) {
    	$columns[] = $output->URL(pnModURL('concert',
                                       'admin',
                                       'view'),
				       _CONCERTEDIT);
	}
	if (pnSecAuthAction(0, 'concert::', "::", ACCESS_MODERATE)&& pnModGetVar('concert','enable_submit')) {
    	$columns[] = $output->URL(pnModURL('concert',
                                       'user',
                                       'submit'),
				       _CONCERTSUBMIT);
	}
	
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($columns);
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableEnd();
		
   // Display status message if any
    $output->BoldText(pnGetStatusMsg());
 		$output->Linebreak(1);
		

    // Return output
    return $output->GetOutput();
}


/**
* Shows concerts calendar table
*
* internal function: it's called from every other function needs to show the concert table
* @return object The html formatted piece of output for table
*/
function concert_user_show() 
{
    // Get parameters from whatever input we need.  All arguments to this
    // function should be obtained from pnVarCleanFromInput(), getting them
    // from other places such as the environment is not allowed, as that makes
    // assumptions that will not hold in future versions of PostNuke
    list($startnum,$what) = pnVarCleanFromInput('startnum','what');

    // Create output object
    $output = new pnHTML();
	
	// Load user API to obtain item information function
    if (!pnModAPILoad('concert', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

	// Get number of items (show it after action title and use it for the Pager function
	$numitems = pnModAPIFunc('concert', 'user', 'countitems',$what);
    
	// Title
	if ($what=='allconc'){
	    $output->Title(_CONCERTVIEWALL);
	}
	else{
	    $output->Title(_CONCERTVIEWNEXT);
	}

    $output->Linebreak(1);
		
	$output->Text(_THEREARE.' '.$numitems.' '._CONCERTS);
    $output->Linebreak(2);

    // Get item information
    $items = pnModAPIFunc('concert', 'user', 'getall',
							array(	'startnum' => $startnum,
                                	'numitems' => pnModGetVar('concert',
                                                          'itemsperpage'),
									'what'=> $what));
	
 
						
    // Start output table
    $output->TableStart('','',1);

    foreach ($items as $item) {

		// split date calling proper internal (module) function
	    if (!pnModAPILoad('concert', 'admin')) {
	        $output->Text(_LOADFAILED);
	        return $output->GetOutput();
	    }	
		
		$date=pnModAPIFunc('concert','admin','expdate',$item['dc_data']);
		if (!$date){
	        $output->Text(_DATE_ERROR);
	        return $output->GetOutput();
		}

        if (pnSecAuthAction(0, 'concert::', ":$item[dc_category]:$item[dc_id]", ACCESS_OVERVIEW)) {

           $output->SetOutputMode(_PNH_KEEPOUTPUT);
			
			$output->TableRowStart();
				$output->TableColStart();
					$output->Text($date['dateshort']);
					
					$output->LineBreak();
					
					switch ($item['dc_conf']){
						case 1:
							$output->Text(_CONCERTNOTCONF);						
						break;
				
						case 2:
							$output->Text(_CONCERTCANCELED);						
						break;
						
						case 3:
							$output->Text(_CONCERTSOLDOUT);
						break;
						
						default:
							$output->Text(_CONCERTCONF);
						break;	
					}
					if ($item['dc_category']==1){
						 $output->Text(' - '._CONCCATRESERVED);
					}
				$output->TableColEnd();
				
				$output->TableColStart();
					$output->BoldText($item['dc_paese']);
					if ($item['dc_prov']) {
						 $output->Text(' ('.$item['dc_prov'].')');
					}
					$output->Text(' '.$item['dc_stato']);
				$output->TableColEnd();
				
				$output->TableColStart();
				
					if ($item['dc_url_locale']){
						if ($item['dc_locale']){					
							$output->URL($item['dc_url_locale'],$item['dc_locale']);
						}
						else {
							$output->URL($item['dc_url_locale'],$item['dc_url_locale']);						
						}
					}
					else {
						if ($item['dc_locale']){
							$output->BoldText($item['dc_locale']);
						}
						else {
						$output->SetInputMode(_PNH_VERBATIMINPUT);
							$output->Text('&nbsp;');
						$output->SetInputMode(_PNH_PARSEINPUT);
						}
					}
					if ($item['dc_indirizzo_locale']){
						$output->LineBreak();
						$output->Text($item['dc_indirizzo_locale']);
					}	
					if ($item['dc_note']){									
						$output->LineBreak();
						// using pnVarPrepHTMLDisplay() with the VERBATIM input mode to allow
						// some html code in notes...
						$output->SetInputMode(_PNH_VERBATIMINPUT);
						$output->Text(pnVarPrepHTMLDisplay($item['dc_note']));
						$output->SetInputMode(_PNH_PARSEINPUT);
					}										
				$output->TableColEnd();
				
				$output->TableColStart();
					if ($item['dc_infotel1']||$item['dc_infotel2']||$item['dc_infomailaddr1']) {					
						$output->Text(_INFO.':');
						if ($item['dc_infotel1']){
							 $output->LineBreak();
							 $output->Text(_TEL.': '.$item['dc_infotelnome1'].' '.$item['dc_infotel1']);
						}	
						if ($item['dc_infotel2']){
							 $output->LineBreak();
							 $output->Text(_TEL.': '.$item['dc_infotelnome2'].' '.$item['dc_infotel2']);
						}	
						if ($item['dc_infomailaddr1']){
							 $output->LineBreak();
							 // using pnVarPrepHTMLDisplay() with the VERBATIM input mode to allow
							 // some html code in email addr...
							 if ($item['dc_infomailnome1']) {
							 		$mailnome=$item['dc_infomailnome1'];
							 }
						}
						else {
								 $mailnome=$item['dc_infomailaddr1'];						
						}
						$output->SetInputMode(_PNH_VERBATIMINPUT);
						$output->Text(pnVarPrepHTMLDisplay('<a href=mailto:'.$item['dc_infomailaddr1'].'><i>'.$mailnome.'</i></a>'));
						$output->SetInputMode(_PNH_PARSEINPUT);									
					}
					else {
							 $output->SetInputMode(_PNH_VERBATIMINPUT);
							 $output->Text('&nbsp;');
							 $output->SetInputMode(_PNH_PARSEINPUT);
					}

				
				$output->TableColEnd();
				
				
				if (pnSecAuthAction(0, 'concert::', ":$item[dc_category]:$item[dc_id]", ACCESS_READ)) {
					$output->TableColStart();
						$output->URL(pnModURL('concert',
                                        'user',
                                        'display',array('dc_id' => $item[dc_id])),
                              _CONCERTDETAILS);
					$output->TableColEnd();
				}	

				
			$output->TableRowEnd();	
					
            $output->SetInputMode(_PNH_PARSEINPUT);
			
        }
    }
    $output->TableEnd();
	
	if (!pnModGetVar('concert', 'itemsperpage')){
		die ('Could not get itemsperpage var');
	}	

    // Call the pnHTML helper function to produce a pager in case of there
    // being many items to display.
    //
    // Note that this function includes another user API function.  The
    // function returns a simple count of the total number of items in the item
    // table so that the pager function can do its job properly
    $output->Pager($startnum, $numitems, pnModURL('concert', 'user', 'view', array('startnum' => '%%','what'=>$what)), pnModGetVar('concert', 'itemsperpage'));

    // Return the output that has been generated by this function
	return $output->GetOutput(); 
}

function concert_user_submit()
{
    // Create output object
    $output = new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'concert::', '::', ACCESS_MODERATE) && pnModGetVar('concert','enable_submit')) {
        $output->Text(_CONCERTNOAUTH.' user_submit');
        return $output->GetOutput();
    }

	// Setting up a scalar array, to avoid warnings in E_ALL state	
	// and to setup default values			
  pnModAPILoad('concert', 'admin');
	$item = pnModAPIFunc('concert','admin','defaults');			 
							 
    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(concert_usermenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_CONCERTSUBMIT);

    // Start form
		pnModLoad('concert', 'admin');
		// we pass the info to a second stage verification..
    $output->FormStart(pnModURL('concert', 'user', 'correct'));
    $output->FormHidden('authid', pnSecGenAuthKey());
	
  	// Common part
    $output->SetInputMode(_PNH_VERBATIMINPUT);	
   	$output->Text(pnModFunc('concert','admin','insertform',$item));
    $output->SetInputMode(_PNH_PARSEINPUT);
	    
    $output->FormSubmit(_CONCERTSUBMIT);
    $output->FormEnd();

    // Return output
    return $output->GetOutput();
}

/**
 * create item from concert_user_submit() calling API function
 */
function concert_user_create()
{	
    // Load API
    pnModAPILoad('concert', 'admin');
		pnModLoad('concert', 'admin');
		
	// get all concert informations
	// we put all that stuffs in a function 'cause they are used either by 
	// concert_admin_update and concert_admin_create 
	$item=pnModFunc('concert','admin','getinfo');
							 
	 // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY.' user_create');
        pnRedirect(pnModURL('concert', 'user', 'main'));
				return true;
    }

	// Checks for a valid date and
	// compact day, year and month in a standard concert format
	$dc_data = pnModAPIFunc('concert','admin','impdate',
                        	array(	'dc_year'			 => $item['dc_year'],
																	'dc_month' 		 => $item['dc_month'], 
																	'dc_day' 			 => $item['dc_day']));
					
    if (!$dc_data) {
      	pnRedirect(pnModURL('concert', 'user', 'correct', $item));
				return true;
    }	
		$item['dc_data']=$dc_data;
		
		// checks for required fields
		// required year, month and day are already checked in previous
		// date check
		if (!pnModAPIFunc('concert','admin','validate',$item)){
      	pnRedirect(pnModURL('concert', 'user', 'correct', $item));
				return true;		
		}

    // Pass to API to create a new item
    $dc_id = pnModAPIFunc('concert','admin','create',$item);

    if ($dc_id != false) {
    	 pnRedirect(pnModURL('concert', 'user', 'submitted'));
			 return true;
    }

  	 pnRedirect(pnModURL('concert', 'user', 'main'));
    return true;
}

/**
 * shows item's data to verifies values
 */
function concert_user_correct()
{
    // Load Functions
    pnModLoad('concert', 'admin');

	// get all concert informations
	// we put all that stuffs in a function 'cause they are used either by 
	// concert_admin_update and concert_admin_create
	$item=pnModFunc('concert','admin','getinfo');

    // Create output object
    $output = new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'concert::', '::', ACCESS_MODERATE)) {
        $output->Text(_CONCERTNOAUTH.' perm. user_correct');
        return $output->GetOutput();
    }
							 
    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(concert_usermenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_CONCERTVERIFYSUBMISSION);

		// some information and advices...
		$output->Text(_CONCERTVERIFYADVICESUBMISSION);
		$output->LineBreak(2);
		
    // Start form
    $output->FormStart(pnModURL('concert', 'user', 'create'));
    $output->FormHidden('authid', pnSecGenAuthKey());
	
	// Common part
    $output->SetInputMode(_PNH_VERBATIMINPUT);	
	$output->Text(pnModFunc('concert','admin','insertform',$item));
    $output->SetInputMode(_PNH_PARSEINPUT);
	    
    $output->FormSubmit(_CONCERTSUBMIT);
    $output->FormEnd();

    // Return output
    return $output->GetOutput();
}

function concert_user_submitted()
{
    // Load API
		pnModAPILoad('concert', 'admin');

    // Create output object
    $output = new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'concert::', '::', ACCESS_MODERATE)) {
        $output->Text(_CONCERTNOAUTH.' user_submitted');
        return $output->GetOutput();
    }

   // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(concert_usermenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_CONCERTSUBMITTED);
		
		$output->LineBreak(2);
		
		$output->Text(_CONCERTTHANKSUBITTED);
		$output->LineBreak(1);
		$output->Text(_CONCERTNOWPENDING.' '.pnModAPIFunc('concert','admin','countpending'));
		
		// Return output
    return $output->GetOutput();
}
/*
* The common part of all the display details functions...
*/
function concert_user_showdetails($item){
		    // Create output object
    $output = new pnHTML();

    // Display item

 		// split date calling proper internal (module) function
	    if (!pnModAPILoad('concert', 'admin')) {
	        $output->Text(_LOADFAILED);
	        return $output->GetOutput();
	    }	
		
		$date=pnModAPIFunc('concert','admin','expdate',$item['dc_data']);
		if (!$date){
	        $output->Text(_DATE_ERROR);
	        return $output->GetOutput();
		}
    // Start output table
    $output->TableStart('','',1);

        if (pnSecAuthAction(0, 'concert::', ":$item[dc_category]:$item[dc_id]", ACCESS_READ)) {

           $output->SetOutputMode(_PNH_KEEPOUTPUT);
			
			$output->TableRowStart();
				$output->TableColStart();
					$output->Text($date['datelong']);
					
					$output->LineBreak();
					
					switch ($item['dc_conf']){
						case 1:
							$output->Text(_CONCERTNOTCONF);						
						break;
				
						case 2:
							$output->Text(_CONCERTCANCELED);						
						break;
						
						case 3:
							$output->Text(_CONCERTSOLDOUT);
						break;
						
						default:
							$output->Text(_CONCERTCONF);
						break;	
					}
					if ($item['dc_category']==1){
						 $output->Text(' - '._CONCCATRESERVED);
					}
				$output->TableColEnd();
				
				$output->TableColStart();
					$output->BoldText($item['dc_paese']);
					if ($item['dc_prov']) {
						 $output->Text(' ('.$item['dc_prov'].')');
					}
					$output->Text(' '.$item['dc_stato']);
				$output->TableColEnd();
				
				$output->TableColStart();
				
					if ($item['dc_url_locale']){
						if ($item['dc_locale']){					
							$output->URL($item['dc_url_locale'],$item['dc_locale']);
						}
						else {
							$output->URL($item['dc_url_locale'],$item['dc_url_locale']);						
						}
					}
					else {
						if ($item['dc_locale']){
							$output->BoldText($item['dc_locale']);
						}
						else {
						$output->SetInputMode(_PNH_VERBATIMINPUT);
							$output->Text('&nbsp;');
						$output->SetInputMode(_PNH_PARSEINPUT);
						}
					}
					if ($item['dc_indirizzo_locale']){
						$output->LineBreak();
						$output->Text($item['dc_indirizzo_locale']);
					}	
					if ($item['dc_note']){									
						$output->LineBreak();
						// using pnVarPrepHTMLDisplay() with the VERBATIM input mode to allow
						// some html code in notes...
						$output->SetInputMode(_PNH_VERBATIMINPUT);
						$output->Text(pnVarPrepHTMLDisplay($item['dc_note']));
						$output->SetInputMode(_PNH_PARSEINPUT);
					}										
				$output->TableColEnd();
				
				$output->TableColStart();
					if ($item['dc_infotel1']||$item['dc_infotel2']||$item['dc_infomailaddr1']) {					
						$output->Text(_INFO.':');
						if ($item['dc_infotel1']){
							 $output->LineBreak();
							 $output->Text(_TEL.': '.$item['dc_infotelnome1'].' '.$item['dc_infotel1']);
						}	
						if ($item['dc_infotel2']){
							 $output->LineBreak();
							 $output->Text(_TEL.': '.$item['dc_infotelnome2'].' '.$item['dc_infotel2']);
						}	
						if ($item['dc_infomailaddr1']){
							 $output->LineBreak();
							 // using pnVarPrepHTMLDisplay() with the VERBATIM input mode to allow
							 // some html code in email addr...
							 if ($item['dc_infomailnome1']) {
							 		$mailnome=$item['dc_infomailnome1'];
							 }
						}
						else {
								 $mailnome=$item['dc_infomailaddr1'];						
						}
						$output->SetInputMode(_PNH_VERBATIMINPUT);
						$output->Text(pnVarPrepHTMLDisplay('<a href=mailto:'.$item['dc_infomailaddr1'].'><i>'.$mailnome.'</i></a>'));
						$output->SetInputMode(_PNH_PARSEINPUT);									
					}
					else {
							 $output->SetInputMode(_PNH_VERBATIMINPUT);
							 $output->Text('&nbsp;');
							 $output->SetInputMode(_PNH_PARSEINPUT);
					}

				
				$output->TableColEnd();
							$output->TableRowEnd();

		    $output->TableEnd();
}
return $output->GetOutput();;
}
?>
